/******************************************************************************

 ::::: __________________________________________________________________ :::::
 : ____\ ._ ____ _____ __. ____ ___ _______ .__ ______ .__ _____ .__ _. /____ :
 __\ .___! _\__/__    / _|__   / _/_____  __|  \ gRK __|_ \  __  |_ \ !___. /__
 \   ! ___/  |/  /___/  |   \__\ ._/  __\/  \   \___/  |/  \/  \_./  \___ !   /
 /__  (___   /\____\____|\   ____|   /  /___|\   ______.    ____\|\   ___)  __\
   /____  \_/ ___________ \_/ __ |__/ _______ \_/ ____ |___/ _____ \_/  ____\
 :     /________________________________________________________________\     :
 :::::       +  p  H  E  N  O  M  p  R  O  D  U  C  T  I  O  N  S  +      :::::
 ==============================================================================

Ignatius' Daydream Frontend 1.0


******************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <signal.h>

#include <dirent.h>
#include <sys/types.h>
#include <unistd.h>
#include <ncurses.h>
#include <errno.h>




/////////// variables /////////////////////////////


    int group;

    const int maxQuestionID = 7;
    const int maxFileID = 4;

    int cmdKey = 0;

    int fileID = 0;
    int questionID = 0;

/////////// end variables /////////////////////////


void init()
{

	printf("\e(U");
        initscr();
        cbreak();
        echo();
        nonl();
        keypad(stdscr, TRUE);
	procs();

}

///////////// main screen /////////////////////////

int main()
{

 int a;

 a = getuid();
        if (a==0)
 {
        printf("Do NOT use as root user! Run as DAYDREAM user!");
        exit(1);
 }

system("clear");
init();

const char *questions[] = {"\e[23;1H\e[1;30m[\e[1;34;44mPROCS\e[0;37m\e[1;30m]  \e[0;37mlogin   snoop   kill   log   binkd   help   quit ", "\e[23;1H\e[0;37m procs  \e[1;30m[\e[1;34;44mLOGIN\e[0;37m\e[1;30m]\e[0;37m  snoop   kill   log   binkd   help   quit ", "\e[23;1H\e[0;37m procs   login  \e[1;30m[\e[1;34;44mSNOOP\e[0;37m\e[1;30m]\e[0;37m  kill   log   binkd   help   quit ", "\e[23;1H\e[0;37m procs   login   snoop  \e[0;37m\e[1;30m[\e[1;34;44mKILL\e[0;37m\e[1;30m]\e[0;37m  log   binkd   help   quit ", "\e[23;1H procs   \e[0;37mlogin   snoop   kill  \e[0;37m\e[1;30m[\e[1;34;44mLOG\e[0;37m\e[1;30m]\e[0;37m  binkd   help   quit ", "\e[23;1H procs   login   snoop   kill   log  \e[0;37m\e[1;30m[\e[1;34;44mBINKD\e[0;37m\e[1;30m]\e[0;37m  help   quit ", "\e[23;1H procs   login   snoop   kill   log   binkd  \e[0;37m\e[1;30m[\e[1;34;44mHELP\e[0;37m\e[1;30m]\e[0;37m  quit ", "\e[23;1H\e[0;37m procs   login   snoop   kill   log   binkd   help  \e[10;37m\e[1;30m[\e[1;34;44mQUIT\e[0;37m\e[1;30m]\e[0;37m"};
const char *files[] = {"\e[12;1H\e[0;37m\e[1;30m[\e[1;36;46mNODE 1\e[0;37m\e[1;30m]\e[0;37m   \e[13;1H \e[0;37mnode 2 \e[14;1H \e[0;37mnode 3 \e[15;1H \e[0;37mnode 4 \e[16;1H \e[0;37mnode 5 ", "\e[12;1H \e[0;37mnode 1 \e[13;1H\e[0;37m\e[1;30m[\e[1;36;46mNODE 2\e[0;37m\e[1;30m]\e[0;37m   \e[14;1H \e[0;37mnode 3 \e[15;1H \e[0;37mnode 4 \e[16;1H \e[0;37mnode 5 ", "\e[12;1H \e[0;37mnode 1 \e[13;1H \e[0;37mnode 2 \e[14;1H\e[0;37m\e[1;30m[\e[1;36;46mNODE 3\e[0;37m\e[1;30m]\e[0;37m   \e[15;1H \e[0;37mnode 4 \e[16;1H \e[0;37mnode 5   ", "\e[12;1H \e[0;37mnode 1 \e[13;1H \e[0;37mnode 2 \e[14;1H \e[0;37mnode 3 \e[15;1H\e[0;37m\e[1;30m[\e[1;36;46mNODE 4\e[0;37m\e[1;30m]\e[0;37m   \e[16;1H \e[0;37mnode 5 ", "\e[12;1H \e[0;37mnode 1 \e[13;1H \e[0;37mnode 2 \e[14;1H \e[0;37mnode 3 \e[15;1H \e[0;37mnode 4 \e[16;1H\e[0;37m\e[1;30m[\e[1;36;46mNODE 5\e[0;37m\e[1;30m]\e[0;37m    "};
    while (cmdKey != 13)
    {
        int cmdKey = getchar();

        switch(cmdKey)
	{
	    case 68: // left
	    case 'a':
                if (questionID > 0) questionID--;
                break;

	    case 67: // right
            case 's':
                if (questionID < maxQuestionID) questionID++;
                break;

	    case 65: // up
            case 'd':
                if (fileID > 0) fileID--;
		break;

	    case 66: // down
	    case 'f':
                if (fileID < maxFileID) fileID++;
		break;

            case 13:
		if (questionID == 0)
		{
		procs();
		break;
		}
		else if (questionID == 1)
		{
		init();
		system("killall -9 watch");
		system("telnet localhost");
		system("clear");
		init();
		break;
		}
		else if (questionID == 0)
		{
		//display();
		break;
		}
		else if (questionID == 3)
		{
		killproc();
		break;
		}
		else if (questionID == 4 & fileID == 0)
		{
		system("killall -9 watch");
		system("less $DAYDREAM/logfiles/daydream1.log");
		system("reset");
		init();
		}
                else if (questionID == 4 & fileID == 1)
                {
		system("killall -9 watch");
                system("less  $DAYDREAM/logfiles/daydream2.log");
		system("reset");
		init();
                }
                else if (questionID == 4 & fileID == 2)
                {
		system("killall -9 watch");
                system("less  $DAYDREAM/logfiles/daydream3.log");
		system("reset");
		init();
                }
                else if (questionID == 4 & fileID == 3)
                {
		system("killall -9 watch");
                system("less  $DAYDREAM/logfiles/daydream4.log");
		system("reset");
		init();
                }
                else if (questionID == 4 & fileID == 4)
                {
		system("killall -9 watch");
                system("less  $DAYDREAM/logfiles/daydream5.log");
		system("reset");
		init();
                }

                else if (questionID == 5)
                {
                system("killall -9 watch");
                system("less /var/log/binkd/binkd");
                system("reset");
                init();
                }
		else if (questionID == 6)
		{
		help();
		}
		else if (questionID == 7)
		{
		quit();
		}

                if (questionID == 2 & fileID == 0)
                {
		system("killall -9 watch");
		system("$DAYDREAM/utils/ddsnoop 1");
		system("reset");
		system("stty -cooked");
                }
		else if (questionID == 2 & fileID == 1)
		{
		system("killall -9 watch");
		system("$DAYDREAM/utils/ddsnoop 2");
		system("reset");
		system("stty -cooked");
		}
                else if (questionID == 2 & fileID == 2)
                {
		system("killall -9 watch");
		system("$DAYDREAM/utils/ddsnoop 3");
		system("reset");
		system("stty -cooked");
                }
		else if (questionID == 2 & fileID == 3)
		{
		system("killall -9 watch");
		system("$DAYDREAM/utils/ddsnoop 4");
		system("reset");
		system("stty -cooked");
		}
		else if (questionID == 2 & fileID == 4)
		{
		system("killall -9 watch");
		system("$DAYDREAM/utils/ddsnoop 5");
		system("reset");
		system("stty -cooked");
		}

        }
        printf("%s\n%s\n",  files[fileID], questions[questionID]);
    }
}

int quit(void)
{
	system("killall -9 watch");
	exit(1);
        return 0;
}

int killproc()
{

     int status, pid;

     printf("\e[21;1HInput PID of process you would like to kill:       ");
     scanf("%d", &pid);

     switch(errno)
     {
         case EINVAL:
             printf("\e[21;1HAn invalid signal was specified.           ");
             break;

         case EPERM:
             printf("\e[21;1HYou don't have permission to kill that PID ");
             break;

         case ESRCH:
             printf("\e[21;1HThat pid or process group does not exist.  ");
             break;

         default:
             printf("\e[21;1HThe PID [%d] has been terminated!          ",pid);
             break;

     }

     status = kill(pid, SIGKILL);
}

int procs(void)
{
         system("watch 'ps -eo pid,comm,cmd,start,etime | grep -v grep | grep daydream'&");
}

int help(void)
{
         printf("\e[9;23H\e[1;34mprocs   \e[1;37m- disp daydream process(es)       ");
         printf("\e[10;23H\e[1;34mlogin   \e[1;37m- login to the system            ");
         printf("\e[11;23H\e[1;34msnoop   \e[1;37m- snoop the selected node        ");
         printf("\e[12;23H\e[1;34mkill    \e[1;37m- kill a daydream process        ");
         printf("\e[13;23H\e[1;34mlog     \e[1;37m- disp logfile for selected node ");
         printf("\e[14;23H\e[1;34mbinkd   \e[1;37m- display the binkd logfile      ");
         printf("\e[15;23H\e[1;34mhelp    \e[1;37m- display this help screen       ");
         printf("\e[16;23H\e[1;34mquit    \e[1;37m- quit the frontend              ");
         printf("\e[17;23H\e[1;34mu/d/l/r \e[1;37m- navigate the interface         ");
         printf("\e[18;23H\e[1;34m<ret>   \e[1;37m- confirm selected operation     ");
}
